#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySailingaTreasureCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySailingaTreasureCFG> M_ActivitySailingaTreasureCFG::msSingleton(nullptr);

int M_ActivitySailingaTreasureCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaTreasureCFGData* M_ActivitySailingaTreasureCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySailingaTreasureCFGData>& M_ActivitySailingaTreasureCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaTreasureCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySailingaTreasureCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaTreasureCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mResources = element->Attribute("Resources");
		{
			const char* AwardItemID = element->Attribute("AwardItemID");
			std::vector<std::string> vecAwardItemID;
			boost::split(vecAwardItemID, AwardItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemID[i].c_str(), &temp))
				{
					data.mAwardItemID.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		{
			const char* PrivilegeName = element->Attribute("PrivilegeName");
			std::vector<std::string> vecPrivilegeName;
			boost::split(vecPrivilegeName, PrivilegeName, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecPrivilegeName.size(); i++)
			{
				data.mPrivilegeName.push_back(vecPrivilegeName[i]);
			}
		}
		{
			const char* PrivilegedResources = element->Attribute("PrivilegedResources");
			std::vector<std::string> vecPrivilegedResources;
			boost::split(vecPrivilegedResources, PrivilegedResources, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecPrivilegedResources.size(); i++)
			{
				data.mPrivilegedResources.push_back(vecPrivilegedResources[i]);
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySailingaTreasureCFG::Load()
{
	Load("../Config/M_ActivitySailingaTreasureCFG.xml");
}

M_ActivitySailingaTreasureCFG* M_ActivitySailingaTreasureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaTreasureCFG());
	}
	return msSingleton.get();
}
